Attribute VB_Name = "modACNMain"
Option Explicit

Public ACN_mode_true As Boolean 'ikawa 01/29/03
Public mode_changed As Boolean   'ikawa 02/14/03
Public ResizingfrmGear As Boolean ' GFH 04/17/06.

Public rowsNumber As Integer 'ik02
Public ACNrowsNumber As Integer
Public ThickrowsNumber As Integer
Public frmGearStarted As Boolean
Public VGAMode As Boolean
Public ScaleModeConst As Double

Public frmGearStartHeight As Double
Public frmGearStartWidth As Double
Public lstLibFileStartHeight As Double
Public lblMessageStartTop As Double
Public grdParmsStartTop As Double
Public grdParmsStartLeft As Double
Public grdOutputStartTop As Double
Public grdOutputStartLeft As Double
Public cmdACNFlexComputeStartTop As Double
Public cmdACNFlexComputeStartLeft As Double
Public cmdACNRigidComputeStartTop As Double
Public cmdACNRigidComputeStartLeft As Double
Public cmdACDesignStartTop As Double
Public cmdACDesignStartLeft As Double
Public cmdPCCDesignStartTop As Double
Public cmdPCCDesignStartLeft As Double
Public cmdHelpStartTop As Double
Public cmdHelpStartLeft As Double
Public cmdAboutStartTop As Double
Public cmdAboutStartLeft As Double
Public fraEditWheelsStartLeft As Double
Public fraLibraryFunctionsStartLeft As Double
Public cmdOutputDetailsStartLeft As Double
Public cmdExitStartLeft As Double
Public picGearStartHeight As Double
Public picGearStartWidth As Double

Public frmACNtxtOutputHeight As Double
Public frmACNtxtOutputStartHeight As Double
Public frmACNgphAlphaHeight As Double
Public frmACNgphAlphaStartHeight As Double
Public frmACNHeight As Double
Public frmACNStartHeight As Double

Public frmACNtxtOutputWidth As Double
Public frmACNtxtOutputStartWidth As Double
Public frmACNgphAlphaWidth As Double
Public frmACNgphAlphaStartWidth As Double
Public frmACNWidth As Double
Public frmACNStartWidth As Double

Public Const SGCol As Integer = 0, SGText$ = "SG"
Public Const CBRCol As Integer = 1, CBRText$ = "CBR"
'Public Const CBRtCol As Integer = 2, CBRtText = "CBR t, in"
Public Const CBRtCol As Integer = 2, CBRtText = "CBR t, " 'modified by Izydor Kawa
Public Const ACNFlexCol As Integer = 3, ACNFlexText = "ACN Flex"

'Public Const kCol As Integer = 4, kText$ = "k, lb/in^3"
Public Const kCol As Integer = 4, kText$ = "k, " 'modyfied by Izydor Kawa
'Public Const RigtCol As Integer = 5, RigtText$ = "Rig t, in"
Public Const RigtCol As Integer = 5, RigtText$ = "Rig t, " 'modified by Izydor Kawa
Public Const ACNRigCol As Integer = 6, ACNRigText$ = "ACN Rig"

Public Sub Main()

  Dim I As Integer
  Dim h1 As Integer, hButton As Integer, h2 As Integer
  
  
  ACN_mode_true = True 'ikawa 02/11/03
  mode_changed = False 'ikawa 02/11/03
  
  Call frmGear.chkUnitsConversion_Click 'code added by Izydor Kawa
  
  ChDir App.Path
  ExtFilePath$ = App.Path & "\"
  If Right$(ExtFilePath$, 1) <> "\" Then ExtFilePath$ = ExtFilePath$ & "\"
'  App.HelpFile = ExtFilePath$ & "ACNcomp.HLP"
  App.HelpFile = ExtFilePath$ & "COMFAA.chm"
  
  ExternalAircraftFileName$ = "COMFAAaircraft"  ' GFH 01/21/03
  If Dir(ExtFilePath$ & ExternalAircraftFileName$ & ".Ext") = "" Then
    Debug.Print "Not new name"
    If Dir(ExtFilePath$ & "AircraftLibrary" & ".Ext") <> "" Then
      ExternalAircraftFileName$ = "AircraftLibrary"
    End If
  End If
  
  FlexibleACN = True
  Call StoreFlexCurveFits
  Call InitACLib
  
  Load frmGear ' into memory, but do not display.
  Load frmACN

  With frmGear
  
    ScaleModeConst = 1
'    Debug.Print .TextWidth("A")
'    Debug.Print .ScaleX(.ScaleWidth, .ScaleMode, vbPixels)
'    Check for large system fonts. .ScaleX is 792 for small fonts
'    880 for large fonts. If the start width is changed then change 800 as required.
    If .ScaleX(.ScaleWidth, .ScaleMode, vbPixels) > 800 Then
      ScaleModeConst = 1.25
    End If
    If ScaleModeConst = 1 Then
      If .ScaleX(Screen.Width, frmGear.ScaleMode, vbPixels) < 800 Then
        .Width = .ScaleX(640, vbPixels, .ScaleMode)
        .Height = .ScaleY(480, vbPixels, .ScaleMode)
        VGAMode = True
      Else
        .Width = .ScaleX(800, vbPixels, .ScaleMode) * 1.008
        .Height = .ScaleY(600, vbPixels, .ScaleMode) * 1.05
      End If
    Else
'      Debug.Print ScaleModeConst; .ScaleX(Screen.Width, frmGear.ScaleMode, vbPixels)
      If .ScaleX(Screen.Width, frmGear.ScaleMode, vbPixels) <= 800 Then
        .Width = .ScaleX(640 * ScaleModeConst, vbPixels, .ScaleMode)
        .Height = .ScaleY(480 * ScaleModeConst, vbPixels, .ScaleMode)
        VGAMode = True
      Else
        .Width = .ScaleX(800 * ScaleModeConst, vbPixels, .ScaleMode)
        .Height = .ScaleY(600 * ScaleModeConst, vbPixels, .ScaleMode)
      End If
    End If
    
    Call MainStartSize
    Call MainSetGrids
'    Call MainResize

    For I = 1 To NLibACGroups
      .lstACGroup.AddItem LibACGroupName$(I)
    Next I
  
    I = lstLibFileIndex
    .lstACGroup.Selected(lstACGroupIndex) = True  ' Sets lstLibFileIndex = 0
    lstLibFileIndex = I                           ' Select last group.
    .lstLibFile.Selected(lstLibFileIndex) = True  ' Select aircraft and plot.
  
    .Left = (Screen.Width - .Width) / 2           ' Finally center.
    .Top = (Screen.Height - .Height) / 2
    
    
    .cmdACDesign.Left = .cmdACNFlexCompute.Left
    .cmdPCCDesign.Left = .cmdACNRigidCompute.Left
  
    .cmdACDesign.Top = .cmdACNFlexCompute.Top + .cmdACNFlexCompute.Height * 1.1
    .cmdPCCDesign.Top = .cmdACNRigidCompute.Top + .cmdACNRigidCompute.Height * 1.1
  
    .fraCompMode.Top = .cmdACNFlexCompute.Top
    .fraCompMode.Left = .cmdACNRigidCompute.Left + .cmdACNRigidCompute.Width * 1.02
'    .chkUnitsConversion.Left = .lstLibFile.Left + 7000 '40 GFH 01/21/03 Removed 04-17-06
'    .chkUnitsConversion.Top = .Height - 3100 '720 GFH 01/21/03 Removed 04-17-06

    .ProgressBar1.Left = .cmdACNFlexCompute.Left
    .ProgressBar1.Top = .grdParms.Top
  
    h1 = .picGear.Height + 2 * .ProgressBar1.Height
    h2 = 230 + 120 + 300 + 200 + 230 + 60 + 120 + 280
  
    hButton = (h1 - h2) / 10
    .cmdAddWheel.Height = hButton
    .cmdRemoveWheel.Height = hButton
    .cmdMoveWheel.Height = hButton
    .cmdSelectWheel.Height = hButton
    .cmdSaveACinLibrary.Height = hButton
    .cmdAddACtoLibrary.Height = hButton
    .cmdRemoveACfromLibrary.Height = hButton
    .cmdOutputDetails.Height = hButton
    .cmdExit.Height = hButton
    .cmdHelp.Height = hButton
    .cmdAbout.Height = hButton
  
    .fraEditWheels.Top = 70 '100
    .cmdAddWheel.Top = 230
    .cmdRemoveWheel.Top = .cmdAddWheel.Top + hButton + 30
    .cmdMoveWheel.Top = .cmdRemoveWheel.Top + hButton + 30
    .cmdSelectWheel.Top = .cmdMoveWheel.Top + hButton + 30
    .fraEditWheels.Height = 4 * hButton + 120 + 280
  
    .fraLibraryFunctions.Top = .fraEditWheels.Top + .fraEditWheels.Height + 120 '200
  
    .cmdSaveACinLibrary.Top = 230
    .cmdAddACtoLibrary.Top = .cmdSaveACinLibrary.Top + hButton + 30
    .cmdRemoveACfromLibrary.Top = .cmdAddACtoLibrary.Top + hButton + 30
    .fraLibraryFunctions.Height = 3 * hButton + 120 + 300
  
  
    .cmdOutputDetails.Top = .fraLibraryFunctions.Top + .fraLibraryFunctions.Height + 120 '200
    .cmdExit.Top = .cmdOutputDetails.Top + hButton + 40
    .cmdHelp.Top = .cmdExit.Top + hButton + 40
    .cmdAbout.Top = .cmdHelp.Top
    .cmdHelp.Left = .cmdExit.Left + .cmdExit.Width / 2 - .cmdHelp.Width - 20
    .cmdAbout.Left = .cmdExit.Left + .cmdExit.Width / 2 + 20
  
'  .Progress_label.Top = .picGear.Top + .picGear.Height - .Progress_label.Height
'   .Progress_label.Top = .picGear.Height - .Progress_label.Height
'       .Progress_label.Top = .ProgressBar1.Top - 100 - .Progress_label.Height
'       .Progress_label.Left = 0

  End With
  
  frmGearStarted = True   ' Allow calls to Form_Resize.
  
  frmGear.Show            ' Display after all sizing is completed.
  
End Sub


Public Sub MainResize()
  
  Dim DeltaHeight As Double, DeltaWidth As Double
  Dim TempDeltaWidth As Double
  
  With frmGear
  
    If .ScaleX(.Width, .ScaleMode, vbPixels) <= 629 Then
      .Width = .ScaleX(629, vbPixels, .ScaleMode)
    End If
    If .ScaleY(.Height, .ScaleMode, vbPixels) <= 500 Then
      .Height = .ScaleY(500, vbPixels, .ScaleMode)
    End If
  
    DeltaHeight = .Height - frmGearStartHeight
    .lblMessage.Top = lblMessageStartTop + DeltaHeight
    .picGear.Height = picGearStartHeight + DeltaHeight
    
    DeltaWidth = .Width - frmGearStartWidth
    .fraEditWheels.Left = fraEditWheelsStartLeft + DeltaWidth
    .fraLibraryFunctions.Left = fraLibraryFunctionsStartLeft + DeltaWidth
    .cmdOutputDetails.Left = cmdOutputDetailsStartLeft + DeltaWidth
    .cmdExit.Left = cmdExitStartLeft + DeltaWidth
    .cmdHelp.Left = .cmdExit.Left + .cmdExit.Width / 2 - .cmdHelp.Width - 20
    .cmdAbout.Left = .cmdExit.Left + .cmdExit.Width / 2 + 20

    .picGear.Width = picGearStartWidth + DeltaWidth
    
    If .Width < frmGearStartWidth Then
      TempDeltaWidth = DeltaWidth
    Else
      TempDeltaWidth = DeltaWidth / 4
    End If
  
    .cmdACNFlexCompute.Move cmdACNFlexComputeStartLeft + TempDeltaWidth, _
                            cmdACNFlexComputeStartTop + DeltaHeight
    .cmdACNRigidCompute.Move cmdACNRigidComputeStartLeft + TempDeltaWidth, _
                             cmdACNRigidComputeStartTop + DeltaHeight
                             
    .cmdACDesign.Left = .cmdACNFlexCompute.Left
    .cmdPCCDesign.Left = .cmdACNRigidCompute.Left
  
    .cmdACDesign.Top = .cmdACNFlexCompute.Top + .cmdACNFlexCompute.Height * 1.25
    .cmdPCCDesign.Top = .cmdACNRigidCompute.Top + .cmdACNRigidCompute.Height * 1.25
  
    .fraCompMode.Top = .cmdACNFlexCompute.Top
    .fraCompMode.Left = .cmdACNRigidCompute.Left + .cmdACNRigidCompute.Width * 1.05

    .grdParms.Move grdParmsStartLeft + TempDeltaWidth, _
                   grdParmsStartTop + DeltaHeight
    .grdOutput.Move grdOutputStartLeft + TempDeltaWidth, _
                    grdOutputStartTop + DeltaHeight
                   
    If .lstLibFile.Left + .lstLibFile.Width > .grdParms.Left Then
      .lstLibFile.Height = .grdParms.Top - .lstLibFile.Top - .lblMessage.Height
    Else
      .lstLibFile.Height = lstLibFileStartHeight + DeltaHeight
    End If
    
    .chkUnitsConversion.Left = .cmdACNRigidCompute.Left + 300
    .chkUnitsConversion.Top = .cmdACNRigidCompute.Top - .chkUnitsConversion.Height * 1.1
    
    .chkNew06Alphas.Left = .cmdACNFlexCompute.Left + 100
    .chkNew06Alphas.Width = 1250
    .chkNew06Alphas.Top = .cmdACNFlexCompute.Top - .chkNew06Alphas.Height * 1.1
    
    .lblXcoord.Top = 20
    .lblYcoord.Top = 20
    .lblXSelected.Top = 20
    .lblYSelected.Top = 20
    
  End With
  
  frmACNHeight = frmACNStartHeight + DeltaHeight
  frmACNtxtOutputHeight = frmACNtxtOutputStartHeight + DeltaHeight
  frmACNgphAlphaHeight = frmACNgphAlphaStartHeight + DeltaHeight
  If DeltaWidth > 0 Then
    frmACNWidth = frmACNStartWidth + DeltaWidth
    frmACNtxtOutputWidth = frmACNtxtOutputStartWidth + DeltaWidth
    frmACNgphAlphaWidth = frmACNgphAlphaStartWidth + DeltaWidth
  Else
    frmACNWidth = frmACNStartWidth
    frmACNtxtOutputWidth = frmACNtxtOutputStartWidth
    frmACNgphAlphaWidth = frmACNgphAlphaStartWidth
  End If

End Sub

Public Sub MainStartSize()

  With frmGear

    If VGAMode Then
      frmGearStartHeight = frmGear.ScaleY(600 * ScaleModeConst, vbPixels, .ScaleMode)
      frmGearStartWidth = frmGear.ScaleX(800 * ScaleModeConst, vbPixels, .ScaleMode)
    Else
      frmGearStartHeight = .Height
      frmGearStartWidth = .Width
    End If
    lstLibFileStartHeight = .lstLibFile.Height
    lblMessageStartTop = .lblMessage.Top
    grdParmsStartTop = .grdParms.Top
    grdParmsStartLeft = .grdParms.Left
    grdOutputStartTop = .grdOutput.Top
    grdOutputStartLeft = .grdOutput.Left
    cmdACNFlexComputeStartTop = .cmdACNFlexCompute.Top
    cmdACNFlexComputeStartLeft = .cmdACNFlexCompute.Left
    cmdACNRigidComputeStartTop = .cmdACNRigidCompute.Top
    cmdACNRigidComputeStartLeft = .cmdACNRigidCompute.Left
    cmdACDesignStartTop = .cmdACDesign.Top
    cmdACDesignStartLeft = .cmdACDesign.Left
    cmdPCCDesignStartTop = .cmdPCCDesign.Top
    cmdPCCDesignStartLeft = .cmdPCCDesign.Left
    cmdHelpStartTop = .cmdHelp.Top
    cmdHelpStartLeft = .cmdHelp.Left
    cmdAboutStartTop = .cmdAbout.Top
    cmdAboutStartLeft = .cmdAbout.Left
    fraEditWheelsStartLeft = .fraEditWheels.Left
    fraLibraryFunctionsStartLeft = .fraLibraryFunctions.Left
    cmdOutputDetailsStartLeft = .cmdOutputDetails.Left
    cmdExitStartLeft = .cmdExit.Left
    picGearStartHeight = .picGear.Height
    picGearStartWidth = .picGear.Width
  
  End With

  frmACNHeight = frmACN.Height
  frmACNStartHeight = frmACNHeight
  frmACNtxtOutputHeight = frmACN.txtOutput.Height
  frmACNtxtOutputStartHeight = frmACNtxtOutputHeight
  frmACNgphAlphaHeight = frmACN.picAlphaCurves.Height
  frmACNgphAlphaStartHeight = frmACNgphAlphaHeight

  frmACNWidth = frmACN.Width
  frmACNStartWidth = frmACNWidth
  frmACNtxtOutputWidth = frmACN.txtOutput.Width
  frmACNtxtOutputStartWidth = frmACNtxtOutputWidth
  frmACNgphAlphaWidth = frmACN.picAlphaCurves.Width
  frmACNgphAlphaStartWidth = frmACNgphAlphaWidth

End Sub

Public Sub MainSetGrids()

  Dim I As Integer
' All plot variables in English units.
  
' Aircraft parameter grid.
  With frmGear.grdParms
  
    ACNrowsNumber = 11
    ThickrowsNumber = ACNrowsNumber + 1
  
    If ACN_mode_true Then
        rowsNumber = ACNrowsNumber
    Else
        rowsNumber = ThickrowsNumber
    End If
  
    .Rows = rowsNumber 'ik02
    .Cols = 2
    .ColWidth(0) = frmGear.TextWidth(" % GW on Main Gears") * 1.25 '1600
    .ColWidth(1) = frmGear.TextWidth("0,000,000") * 1.2
    I = .Rows - 1
    .Height = (.RowPos(I) + .RowHeight(I)) + 6 * Screen.TwipsPerPixelY
    I = .Cols - 1
    .Width = (.ColPos(I) + .ColWidth(I)) + 6 * Screen.TwipsPerPixelX
  
    .ColAlignment(0) = 0 'grdAlignLeft
    .ColAlignment(1) = 2 'grdAlignCenter

    .Col = 0
    GrossWeightRow = 0
      .Row = GrossWeightRow:       .Text = " Gross Weight (" _
      & UnitsOut.poundsName & ")" 'modified by Izydor Kawa
    PcntOnMainGearsRow = 1
      .Row = PcntOnMainGearsRow:   .Text = " % GW on Main Gears"
    NMainGearsRow = 2
      .Row = NMainGearsRow:        .Text = " No. Main Gears"
    NWheelsRow = 3
      .Row = NWheelsRow:           .Text = " Wheels on Main Gear"
    
    TirePressureRow = 4

      If ACN_mode_true Then 'ik03
        .Row = TirePressureRow:      .Text = " Tire Pressure (" _
               & UnitsOut.psiName & ")" 'modified by Izydor Kawa
      Else
        .Row = TirePressureRow:      .Text = " Tire Contact Area (" _
               & UnitsOut.squareInchName & ")" 'modified by Izydor Kawa
      End If
      
    InputAlphaRow = 5
      .Row = InputAlphaRow:               .Text = " Input Alpha"
    AlphaFactorRow = 6
      .Row = AlphaFactorRow:              .Text = " Alpha Used"
    CoveragesRow = 7
      .Row = CoveragesRow:                .Text = " Coverages (20 yr total)"
    FlexibleAnnualDeparturesRow = 8
'      .Row = FlexibleAnnualDeparturesRow: .Text = " Flex Annual Departures" ' Now set in Sub WriteParmGrid.
    RigidAnnualDeparturesRow = 9
'      .Row = RigidAnnualDeparturesRow:    .Text = " Rigid Annual Departures" ' Now set in Sub WriteParmGrid.
    RigidCutoffRow = 10
      .Row = RigidCutoffRow:              .Text = " Rigid Cutoff (times rrs)"
'Izydor code Begin
    If Not ACN_mode_true Then ' GFH 11/27/06.
      FlexStrengthOfConcRow = RigidCutoffRow + 1
      .Row = FlexStrengthOfConcRow: .Text = " Rc (" & UnitsOut.psiName & ")"
    End If
'Izydor code End
  End With
  
' Output grid.
  With frmGear.grdOutput
  
    .Rows = 5
    .Cols = 7
    For I = 0 To .Cols - 1
      .ColAlignment(I) = 2 'grdAlignCenter
    Next I
    .Row = 0
    .ColWidth(SGCol) = frmGear.TextWidth(SGText) * 1.2
    .Col = SGCol:    .Text = SGText
    .ColWidth(CBRCol) = frmGear.TextWidth(CBRText) * 1.5
    .Col = CBRCol:    .Text = CBRText
    .ColWidth(CBRtCol) = frmGear.TextWidth(CBRtText & UnitsOut.inchName) * 1.1 'modyfied by Izydor Kawa
    .Col = CBRtCol:    .Text = CBRtText & UnitsOut.inchName  'modyfied by Izydor Kawa
    
    .ColWidth(ACNFlexCol) = frmGear.TextWidth(ACNFlexText) * 1.1
    
    .Col = ACNFlexCol:    .Text = ACNFlexText
    .ColWidth(kCol) = frmGear.TextWidth(kText & UnitsOut.pciName) * 1.1 'modyfied by Izydor Kawa
    .Col = kCol:    .Text = kText & UnitsOut.pciName 'modyfied by Izydor Kawa
    
    .ColWidth(RigtCol) = frmGear.TextWidth(RigtText & UnitsOut.inchName) * 1.1 'modyfied by Izydor Kawa
    .Col = RigtCol:    .Text = RigtText & UnitsOut.inchName 'modyfied by Izydor Kawa
    
    .ColWidth(ACNRigCol) = frmGear.TextWidth(ACNRigText) * 1.1
    .Col = ACNRigCol:    .Text = ACNRigText
    
    .Col = SGCol
    .Row = 1:    .Text = " D"
    .Row = 2:    .Text = " C"
    .Row = 3:    .Text = " B"
    .Row = 4:    .Text = " A"

    I = .Rows - 1
    .Height = (.RowPos(I) + .RowHeight(I)) + 6 * Screen.TwipsPerPixelY
    I = .Cols - 1
    .Width = (.ColPos(I) + .ColWidth(I)) + 6 * Screen.TwipsPerPixelX
  
  End With

End Sub
